/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.data;//属于data这个包

import android.content.Context;
import android.database.Cursor;
import android.provider.ContactsContract.CommonDataKinds.Phone;
import android.provider.ContactsContract.Data;
import android.telephony.PhoneNumberUtils;
import android.util.Log;

import java.util.HashMap;
/**
 * @Package:        net.micode.notes.data
 * @ClassName:      Contact
 * @Description:
 * Contact类用于查询联系人信息并进行缓存。
 * 该类包含一个静态的HashMap作为缓存，存储电话号码和对应的联系人名字。
 * 通过调用getContact方法可以根据给定的电话号码查询联系人名字。
 * 如果缓存中已经存在该电话号码对应的联系人名字，则直接返回缓存中的结果，否则通过查询数据库获取联系人名字并更新缓存。
 * 该类还定义了一个私有的SQL筛选语句用于查询联系人信息。
 * 注意：该类是线程不安全的，如果需要在多线程环境下使用，请做好同步控制
 * @Author:         YangYizhe
 * @CreateDate:     12/17/2023 10:10 AM
 * @Version:        1.0
 */
public class Contact {
    /**
     * 作为缓存,存储电话号码和对应的联系人名字
     */
    private static HashMap<String, String> sContactCache;
    private static final String TAG = "Contact";//设置日志TAG标签

    //查询联系人的SQL筛选语句
    private static final String CALLER_ID_SELECTION = "PHONE_NUMBERS_EQUAL(" + Phone.NUMBER
    + ",?) AND " + Data.MIMETYPE + "='" + Phone.CONTENT_ITEM_TYPE + "'"
    + " AND " + Data.RAW_CONTACT_ID + " IN "
            + "(SELECT raw_contact_id "
            + " FROM phone_lookup"
            + " WHERE min_match = '+')";
    //获取联系人
    public static String getContact(Context context, String phoneNumber) {
        if(sContactCache == null) {/*如果缓存为空，就新建一个*/
            sContactCache = new HashMap<String, String>();
        }

        if(sContactCache.containsKey(phoneNumber)) {/*如果缓存中已经有该电话号码对应的联系人名字，就直接返回*/
            return sContactCache.get(phoneNumber);
        }

        String selection = CALLER_ID_SELECTION.replace("+",
                PhoneNumberUtils.toCallerIDMinMatch(phoneNumber));//将电话号码转换为最小匹配模式，用于筛选
        Cursor cursor = context.getContentResolver().query(
                Data.CONTENT_URI,
                new String [] { Phone.DISPLAY_NAME },
                selection,//使用筛选条件
                new String[] { phoneNumber },
                null);

        if (cursor != null && cursor.moveToFirst()) {//如果找到了符合条件的联系人
            try {
                String name = cursor.getString(0);//获取联系人名字
                sContactCache.put(phoneNumber, name);//将电话号码和联系人名字添加到缓存中
                return name;//返回联系人名字
            } catch (IndexOutOfBoundsException e) {
                Log.e(TAG, " Cursor get string error " + e.toString());
                return null;
            } finally {
                cursor.close();//关闭游标
            }
        } else {/*没找到*/
            Log.d(TAG, "No contact matched with number:" + phoneNumber);
            return null;
        }
    }
}
